#include <stdlib.h>
#include <stdio.h>
#include "lyapunov.h"

// --------------------------------------------------------------------------
//                      READ_TABLE
// --------------------------------------------------------------------------

void read_table( const char * file )
{
	FILE * fp;
	int l, t, degx, degy;
	double re, im;
	
	vec_field = (struct hom_poly *)malloc( sizeof( struct hom_poly ) );
	vec_field->next_hom_poly = NULL;

	fp = fopen( file, "r" );
	if( fp == NULL )
	{
		perror(file);
		exit(-5);
	}

	fscanf( fp, "%d %lf", &weakness_level, &precision );
	fscanf( fp, "%i\n\n", &l );
	for( t = 1; t <= l; t++ )
	{
		fscanf( fp, "%i\n\n%i\n\n%lf\n\n%lf\n\n", &degx, &degy, &re, &im );
		ins_hom_poly( vec_field, degx, degy, re, im );
	}
	fclose( fp );
}
