procedure saddle_inf(f,chart,x0,l1,b,l2,degree);
begin scalar c,ff,g,h,stable,sep,trans,type;
c:=b/(l2-l1);
ff:=translation(sub(z1=x,z2=y,f),x0,0);
trans:=mat((c,1),(1,0));
g:=transformation(ff,trans);
h:=normalization(g);

write "Moving this saddle point to the origin";
write "The new vector field is",ff;
write "Transform this vector field so that the linear part is diagonal";
write "The new vecor field is",g;
write "Make a 1000-normalization";
write "So the new vector field is",h;
if save_all then
<<openfile(result_file); 
 write "Moving this saddle point to the origin";
 write "The new vector field is",ff;
 write "Transform this vector field so that the linear part is diagonal";
 write "The new vecor field is",g;
 write "Make a 1000-normalization";
 write "So the new vector field is",h;
 out 't;
>>;
write "We calculate the invariant separatrices";
if llt(l2,0) then stable:=1 else stable:=0;
sep:=manifold(h,taylor_level,stable);
if stable=1 then 
 <<write "the stable separatrice is",{t,sep};
   write "the unstable separatrice is",{0,t};
   if save_all then
   <<openfile(result_file);
     write "the stable separatrice is",{t,sep};
     write "the unstable separatrice is",{0,t};
     out 't; 
   >>  >>
else
 <<write "the unstable separatrice is",{t,sep};
   write "the stable separatrice is",{0,t};
   if save_all then
   <<openfile(result_file);
     write "the unstable separatrice is",{t,sep};
     write "the stable separatrice is",{0,t};
     out 't; 
   >>  >>;
if stable=1 then type:=-1
            else type:=1;
write_saddle(x0,0,c,1,1,0,h,{sep},{type},chart);
if(p=1 and q=1) then
% type of sep on the V-chart if we working on the poincare sfeer
 <<if stable=1 then 
               <<if degree neq 0 then type:=1>>
               else if degree neq 0 then type:=-1; 
   if chart=1 then write_saddle(x0,0,-c,1,-1,0,h,{sub(t=-t,sep)},{type},3)
   else write_saddle(x0,0,-c,1,-1,0,h,{sub(t=-t,sep)},{type},4);
 >>;
end;

procedure se_inf(f,chart,x0,l1,b,l2,degree);
begin scalar h,c,ff,trans,g,s1,m,a_m,type,center_sep,sep,a;

c:=b/(l2-l1);
ff:=translation(sub(z1=x,z2=y,f),x0,0);
trans:=mat((c,1),(1,0));
g:=transformation(ff,trans);
h:=normalization(g);


write "the point (",x0,",",0,") is a semi hyperbolic point";
write "Moving this point to the origin";
write "The new vector field is",ff;
write "Transform this vector field so that the linear part is diagonal";
write "The new vecor field is",g;
write "Make a 1000-normalization";
write "So the new vector field is",h;
openfile(result_file);
write "the point (",x0,",",0,") is a semi hyperbolic point";
if save_all then
<<write "Moving this  point to the origin";
  write "The new vector field is",ff;
  write "Transform this vector field so that the linear part is diagonal";
  write "The new vecor field is",g;
  write "Make a 1000-normalization";
  write "So the new vector field is",h;
>>;  
out 't;
write "We calculate the invariant separatrices";
if eeq(l1,0) then
<<% z2=0 is the center-separatrice
  if llt(l2,0) then stable:=1 else stable:=0;
  sep:=manifold(h,taylor_level,stable);
  %determing the type of semi elementary
  s1:=first_term(sub(z2=0,first f),z1);
  on ratarg; m:=deg(s1,z1); off ratarg;
  a_m:=sign(evalf(sub(z1=1,s1)));
  if evenp(m) then
  if a_m=1 then 
   if  stable=0 then type:={1,0} % saddle-node  ,0 is z2=0 center
                else type:={2,0} % saddle-node
           else
   if stable=0 then type:={3,0}  % saddle-node
               else type:={4,0}  % saddle-node
            else
  if a_m=1 then
   if stable=0 then type:={5,0}  % unstable node
               else type:={6,0}  % saddle
           else
   if stable=0 then type:={7,0}  % saddle
               else type:={8,0}; % stable node
  openfile(result_file);
  if member(type,{{1,0},{2,0},{3,0},{4,0}}) then write "the point is a saddle-node"
  else if type={5,0} then write "the point is an unstable node"
  else if type={8,0} then write "the point is a stable node"            
  else write "the point is a saddle";
  out 't;
>>
else 
<< %z2=0 is not the center-seperatrice
   if llt(l1,0) then stable:=1 else stable:=0;
   center_sep:=center_manifold(h,taylor_level,stable);
   sep:=sub(x='t,first center_sep);
   type:=append({last center_sep},{1}); % 1 is z2=0 not center
   openfile(result_file);
  if member(type,{{1,1},{2,1},{3,1},{4,1}}) then write "the point is a saddle-node"
  else if type={5,1} then write "the point is an unstable node"
  else if type={8,1} then write "the point is a stable node"            
  else write "the point is a saddle";
  out 't; 
>>;

write_semi_elementary(x0,0,c,1,1,0,h,type,{sep},chart);
if (p=1 and q=1) then 
<<if degree=0 then
   if last type=0 then
    <<a:=first type;
      if a=1 then a:=3
      else if a=2 then a:=4
      else if a=3 then a:=1
      else if a=4 then a:=2;
      type:={a,0}>>
   else
    <<a:=first type;
      if a=1 then a:=3
      else if a=2 then a:=4
      else if a=3 then a:=1
      else if a=4 then a:=2;
      type:={a,1}>>
  else 
   if last type=0 then
    <<a:=first type;
      if a=1 then a:=2
      else if a=2 then a:=1
      else if a=3 then a:=4
      else if a=4 then a:=3
      else if a=5 then a:=8
      else if a=6 then a:=7
      else if a=7 then a:=6
      else if a=8 then a:=5;
      type:={a,0}>>
   else
    <<a:=first type;
      if a=1 then a:=2
      else if a=2 then a:=1
      else if a=3 then a:=4
      else if a=4 then a:=3
      else if a=5 then a:=8
      else if a=6 then a:=7
      else if a=7 then a:=6
      else if a=8 then a:=5;
      type:={a,1}>>;
 if chart=1 then write_semi_elementary(x0,0,c,1,1,0,
                  {(-1)^degree*first h,(-1)^degree*second h},type,{sep},3)
 else write_semi_elementary(x0,0,c,1,1,0,
                  {(-1)^degree*first h,(-1)^degree*second h},type,{sep},4); 
>>
end;

procedure change_stab(sep);
begin scalar j,trajectors,a,b,c,l;
trajectors:={};
for j:=1:length(sep) do
<<a:={};
  b:=part(sep,j);
  for l:=1:length(b) do
  if l neq 6 then a:=append(a,{part(b,l)})
             else <<c:=part(b,l);
                    if member(c,{1,3,9,10}) then c:=2
                    else if member(c,{2,4,11,12}) then c:=1
                    else if member(c,{5,7}) then c:=6
                    else c:=5;
                    a:=append(a,{c});>>;
  trajectors:=append(trajectors,{a});
>>;
return trajectors;
end;


procedure de_inf(f,chart,x0,degree);
begin scalar trajectors;
write "point (",x0,",0) is a non elementary point";
write "blowing up the vector field";
trajectors:=blowing_up(sub(z1=x,z2=y,f),x0,0,0); % infinite point
write_degenerate(x0,0,first trajectors,chart);
if (p=1) and (q=1) then 
<<write "degree=",degree;
  if degree=0 then trajectors:=second trajectors
             else trajectors:=change_stab(second trajectors);
  if chart=1 then write_degenerate(x0,0,trajectors,3) 
            else write_degenerate(x0,0,trajectors,4); >>
end;

procedure type_inf(f,chart,x0,l1,b,l2,degree);
begin scalar l; 


if eeq(l1,0) and eeq(l2,0) then
 <<write "(",x0,",0) is non-elementary";
   openfile(result_file);
   write "(",x0,",0) is non-elementary";
   out 't;
   de_inf(f,chart,x0,degree);
 >>
else if eeq(l1,0) or eeq(l2,0) then
   se_inf(f,chart,x0,l1,b,l2,degree)
else if llt(l1*l2,0) then
 <<write "(",x0,",0) is a saddle";
   openfile(result_file);
   write "(",x0,",0) is a saddle";
   out 't;
   saddle_inf(f,chart,x0,l1,b,l2,degree); 
 >>
else 
 <<l:=sign(evalf(l2));
   if l=1 then
    <<write "(",x0,",0) is an unstable node";
      openfile(result_file);
      write "(",x0,",0) is an unstable node";
      out 't;
    >>
   else
    <<write "(",x0,",0) is a stable node";
      openfile(result_file);
      write "(",x0,",0) is a stable node";
      out 't;
    >>;
   write_node(x0,0,l,chart);
   if (p=1) and (q=1) then
    <<if degree neq 0 then l:=-l;
      if chart=1 then write_node(x0,0,l,3)
      else write_node(x0,0,l,4);
    >>
 >> ;      
end;
 


procedure find_inf_roots(d,f,f_U1,f_U2,x,y,degree);
begin scalar p_d,q_d,p,q,h,g,r,j,a,tot;

p_d:=nterm(first f,x,y,d);
q_d:=nterm(second f,x,y,d);
p:=nterm(first f,x,y,d-1);
q:=nterm(second f,x,y,d-1);

% roots in the U1-chart
h:=sub(x=1,q_d)-y*sub(x=1,p_d);
g:=find_real_roots1(h,y);
openfile(log_file);
write 2*(length(first g)+length(second g)); % number of critical points in U1 chart 
out 't;
tot:=length(first g)+length(second g);
write "THE DIFF SYSTEM ON THE U1-CHART:";
write "z1'=",first f_U1;
write "z2'=",second f_U1;
openfile(result_file);
write "First we study the system on the U1-chart (x=1/z2,y=z1/z2)";
write "z1'=",first f_U1;
write "z2'=",second f_U1;
if save_all then
write " we change z1->x, z2->y";
out 't; 

for j:=1:length(first g) do
<<a:=part(first g,j);
  type_inf(f_U1,1,a,sub(y=a,df(h,y)),sub(x=1,y=a,q-y*p),-sub(x=1,y=a,p_d),
   degree);
>>;
r:=symbolic !*rounded;
on rounded;
for j:=1:length(second g) do
<<a:=part(second g,j);
  type_inf(f_U1,1,a,sub(y=a,df(h,y)),sub(x=1,y=a,q-y*p),-sub(x=1,y=a,p_d),
   degree);
>>;
if not r then off rounded;



%roots in the U2-chart
h:=sub(y=1,p_d)-x*sub(y=1,q_d);
% (0,0) a singular point ?
if eeq(sub(x=0,h),0) then g:={0} else g:={};
openfile(log_file);
write 2*length(g); 
out 't;
tot:=tot+length(g);
write "THE DIFF SYSTEM ON THE U2-CHART:";
write "z1'=",first f_U2;
write "z2'=",second f_U2;
openfile(result_file);
write "Now we study the system on the U2-chart (x=z1/z2,y=1/z2)";
write;
write "z1'=",first f_U2;
write "z2'=",second f_U2;
if save_all then
write "we change z1->x, z2->y";
out 't;
for j:=1:length(g) do
<<a:=part(g,j);
  type_inf(f_U2,2,a,sub(x=a,df(h,x)),sub(x=a,y=1,p-x*q),-sub(x=a,y=1,q_d),
   degree);
>>;
if tot=0 then behaviour_inf(f,d);
end;

procedure find_inf_roots_sing(f_U1,f_U2);
% find the roots in U1(2)-chart if z2=0 is a line of singularities
begin scalar g,r,j,a;

% roots in the U1-chart
g:=find_real_roots1({sub(z2=0,first f_U1),sub(z2=0,second f_U1)},z1);
openfile(log_file);
write (length(first g)+length(second g)); % number of critical points in U1 chart 
out 't;
write "THE DIFF SYSTEM ON THE U1-CHART:";
write "z1'=",first f_U1;
write "z2'=",second f_U1;
openfile(result_file);
write "First we study the system on the U1-chart (x=1/z2,y=z1/z2)";
write "z1'=",first f_U1;
write "z2'=",second f_U1;
if save_all then write " we change z1->x, z2->y";
out 't; 
for j:=1:length(first g) do type(sub(z1=x,z2=y,f_U1),part(first g,j),0,1);
r:=symbolic !*rounded;
on rounded;
for j:=1:length(second g) do type(sub(z1=x,z2=y,f_U1),part(second g,j),0,1);
if not r then off rounded;



%roots in the U2-chart
if eeq(sub(z1=0,z2=0,first f_U2),0) and eeq(sub(z1=0,z2=0,second f_U2),0)
  then g:={0} else g:={};

openfile(log_file);
write length(g);
out 't;
write "THE DIFF SYSTEM ON THE U2-CHART:";
write "z1'=",first f_U2;
write "z2'=",second f_U2;
openfile(result_file);
write "Now we study the system on the U2-chart (x=z1/z2,y=1/z2)";
write;
write "z1'=",first f_U2;
write "z2'=",second f_U2;
if save_all then write "we change z1->x, z2->y";
out 't;
for j:=1:length(g) do type(sub(z1=x,z2=y,f_U2),0,0,2);
end;

procedure vec_field_diff_chart(f,x,y);
begin scalar d,f_U1,f_U2,f_V1,f_V2,degree,sing;
clear z1,z2;
d:=max(ddeg(first f,x,y),ddeg(second f,x,y));
f_U1:={z2^d*(-z1*sub(x=1/z2,y=z1/z2,first f)+sub(x=1/z2,y=z1/z2,second f)),
       -z2^(d+1)*sub(x=1/z2,y=z1/z2,first f)};
f_V1:={z2^d*(z1*sub(x=-1/z2,y=z1/z2,first f)+sub(x=-1/z2,y=z1/z2,second f)),
       z2^(d+1)*sub(x=-1/z2,y=z1/z2,first f)};
f_U2:={z2^d*(sub(x=z1/z2,y=1/z2,first f)-z1*sub(x=z1/z2,y=1/z2,second f)), 
       -z2^(d+1)*sub(x=z1/z2,y=1/z2,second f)};
f_V2:={z2^d*(sub(x=z1/z2,y=-1/z2,first f)+z1*sub(x=z1/z2,y=-1/z2,second f)), 
       z2^(d+1)*sub(x=z1/z2,y=-1/z2,second f)};

if not member(all_crit_points,{1,3}) then
<<
  write "we make use of the Poincare disc ";
  openfile(result_file);
  write "we make the study on the Poincare disc ";
  write;
  out 't;
>>;  
% infinity line of singularities ??
if(sub(z2=0,first f_U1)=0) and (sub(z2=0,second f_U1)=0) then
<< if not member(all_crit_poins,{1,3}) then
   <<write "Infinity is a line of singularities ";
     openfile(result_file);
     write "Infinity is a line of singularities ";
     out 't;
   >>;
   f_U1:={first f_U1/z2,second f_U1/z2};
   f_U2:={first f_U2/z2,second f_U2/z2};
   f_V1:={first f_V1/z2,second f_V1/z2};
   f_V2:={first f_V2/z2,second f_V2/z2};
   sing:=1; % we have a line of singularities
>>   
else sing:=0;
   



% writing the different vector fields to vec_table
openfile(vec_table);
write_vec_field(sub(z1=x,z2=y,f_U1));
write_vec_field(sub(z1=x,z2=y,f_V1));
write_vec_field(sub(z1=x,z2=y,f_U2));
write_vec_field(sub(z1=x,z2=y,f_V2));
write sing;
if evenp(d-1) then <<degree:=0; write 1;>>
else <<degree:=1; write "-1";>>;
out 't;


if not member(all_crit_points,{1,3}) then 
 if sing=0 then find_inf_roots(d,f,f_U1,f_U2,x,y,degree)
 else find_inf_roots_sing(f_U1,f_U2);
end;
