procedure behaviour_inf(f,d);
begin scalar g,p1,q1,r,s,aa10,aa01,bb10,lyp,l1,l2,jac,delta,rho,sigma;
% we try to get the behaviour at infinity if there are no singularities at 
% infinity
% THERE IS A ERROR !!!!

p1:=sub(x=x/(x^2+y^2),y=y/(x^2+y^2),first f);
q1:=sub(x=x/(x^2+y^2),y=y/(x^2+y^2),second f);
g:={(x^2+y^2)^d*((x^2+y^2)*p1-2*x*(x*p1+y*q1)),
    (x^2+y^2)^d*((x^2+y^2)*q1-2*y*(x*p1+y*q1))};

jac:=jacobian(g,0,0);
delta:=first jac*part(jac,4)-second jac*part(jac,3);
rho:=first jac+part(jac,4);
sigma:=rho^2-4*delta;

if llt(sigma,0) then
 if eeq(rho,0) then
  <<% weak focus
    %going in rounded mode
    r:=symbolic !*rounded;
    on rounded;
    on ratarg;
    aa10:=coeffn(coeffn(first g,x,1),y,0);
    aa01:=coeffn(coeffn(first g,x,0),y,1);
    bb10:=coeffn(coeffn(second g,x,1),y,0);
    s:=sqrt(-aa01*bb10-aa10*aa10);
    g:={bb10*sub({x=-s*x/bb10+aa10*y/bb10},first g)/s^2-
        aa10*sub({x=-s*x/bb10+aa10*y/bb10},second g)/s^2,
       -sub({x=-s*x/bb10+aa10*y/bb10},second f)/s};
    g:=sub({x=(zz+zzb)/2,y=-i*(zz-zzb)/2},first g)+
       i*sub({x=(zz+zzb)/2,y=-i*(zz-zzb)/2},second g);
    g:=g/coeffn(coeffn(coeffn(g,i,1),zz,1),zzb,0);
    lyp:=lyapunov(gg-i*zz);
    if first lyp neq 0 then
     << write "order of weakness is ",second lyp;
        write "lyapunov coeff is ",- first lyp;
        openfile(result_file);
        write "order of weakness is ",second lyp;
        write "lyapunov coeff is ",- first lyp;
        out 't;
        if first lyp<0 then << write "The equator is weak repelling";
                               openfile(result_file);
                               write "The equator is weak repelling";
                               out 't;
                               type:=1;
                             >>   
                       else << write "The equator is weak attracting"; 
                               openfile(result_file);
                               write "The equator is weak attracting";
                               out 't;
                               type:=-1;
                                >>;
     >>
    else
     if third lyp=2 or last lyp=1 then << write "We have a centre ";
                                          openfile(result_file);
                                          write "We have a centre behaviour at infinity";
                                          out 't;
                                          type:=4;
                                       >>                
                                  else << write "The order of weakness is at least ", weakness_level+1;
                                          openfile(result_file);
                                          write "The order of weakness is at least ", weakness_level+1;
                                          out 't;
                                          type:=0;
                                       >>;  
           
   if not r then off rounded;
   openfile(result_file);
   write "######################################################################################";
   out 't;
   if not r then off rounded;
   off ratarg;
 >>
 else
 << %strong focus
    l1:=(rho-sqrt(sigma))/2;
    l2:=(rho+sqrt(sigma))/2;
    if gt(rho,0) then
     << write  "The equator is repelling"; 
        openfile(result_file);
        write "The equator is repelling";
        out 't;
     >>
    else
     << write "The equator is attracting";
        openfile(result_file);
        write "The equator is attrcting";
        out 't;
     >>;
 >>;   
end;    