#
# P5 PROJECT FILE.  Use qmake to build makefile
#

CONFIG +=   qt
CONFIG -=   debug_and_release
CONFIG -=   debug

RC_FILE =   p5.rc

HEADERS =   color.h         \
        custom.h        \
        file_vf.h       \
        math_p4.h       \
        p5application.h     \
        table.h         \
        win_about.h     \
        win_curves.h    \
        win_find.h      \
        win_gcf.h       \
        win_inputsphere.h   \
        win_intparams.h     \
        win_legend.h        \
        win_limitcycles.h   \
        win_main.h      \
        win_orbits.h        \
        win_p5.h        \
        win_params.h        \
        win_plot.h      \
        win_print.h     \
        win_separatrices.h  \
        win_settings.h      \
        win_sphere.h        \
        win_vf.h        \
        win_vfselect.h  \
        win_view.h      \
        win_zoom.h      \
        ../version.h

SOURCES =   file_paths.cpp      \
        file_tab.cpp        \
        file_vf.cpp     \
        main.cpp        \
        math_changedir.cpp  \
        math_charts.cpp     \
        math_curves.cpp     \
        math_findpoint.cpp  \
        math_gcf.cpp        \
        math_limitcycles.cpp    \
        math_numerics.cpp   \
        math_orbits.cpp     \
        math_p4.cpp     \
        math_polynom.cpp    \
        math_regions.cpp    \
        math_desep.cpp      \
        math_sesep.cpp      \
        math_saddlesep.cpp   \
        math_separatrice.cpp \
        p5settings.cpp      \
        plot_points.cpp     \
        plot_tools.cpp      \
        print_bitmap.cpp    \
        print_points.cpp    \
        print_postscript.cpp    \
        print_xfig.cpp      \
        win_about.cpp       \
        win_curves.cpp      \
        win_debug.cpp       \
        win_find.cpp        \
        win_gcf.cpp         \
        win_inputsphere.cpp \
        win_intparams.cpp   \
        win_legend.cpp      \
        win_limitcycles.cpp \
        win_main.cpp        \
        win_orbits.cpp      \
        win_params.cpp      \
        win_plot.cpp        \
        win_print.cpp       \
        win_separatrices.cpp    \
        win_settings.cpp    \
        win_sphere.cpp      \
        win_vf.cpp          \
        win_vfselect.cpp    \
        win_view.cpp        \
        win_zoom.cpp
