#include <qtextedit.h>
#include <qapplication.h>
#include <qmessagebox.h>
#include <stdarg.h>
#include "p5application.h"
 
extern void SetP4WindowTitle( QWidget *, QString );

static QTextEdit * DumpScr = NULL;

void Debug( const char * format, ... )
{
    char buffer[4096];
    va_list ap;
    
    if( DumpScr == NULL )
    {
        DumpScr = new QTextEdit();
        DumpScr->setFont( *(p5app->CourierFont) );
        DumpScr->setReadOnly(true);
        DumpScr->resize(640,480);
        SetP4WindowTitle( DumpScr, "DEBUG SCREEN" );
        DumpScr->show();
    }

    va_start(ap,format);
    vsprintf( buffer, format, ap );
    DumpScr->append( buffer );
}

void DebugBox( const char * format, ... )
{
    char buffer[4096];
    va_list ap;
    
    va_start(ap,format);
    vsprintf( buffer, format, ap );

    QMessageBox::critical( NULL, "P5 Debug", buffer );
}
