#include <qwidget.h>

class QFindDlg;
class QBoxLayout;
class QHBoxLayout;
class QLabel;
class QComboBox;
class QPushButton;
class QCurvesDlg;

class QVFSelectDlg : public QWidget
{
    Q_OBJECT
public:
    QComboBox * cbb_vfselect;
    QPushButton * btn_add;
    QPushButton * btn_del;
    QPushButton * btn_prev;
    QPushButton * btn_next;
    QPushButton * btn_p5config;
    QCurvesDlg * win_curves;

public:
    QVFSelectDlg( QFindDlg * startwindow );
    ~QVFSelectDlg();

    void GetDataFromDlg( void );
    void UpdateDlgData( void );

    void CloseConfigWindow( void );
    bool CheckPlotWindowClosed( void );

public slots:
    void OnBtnAdd( void );
    void OnBtnDel( void );
    void OnBtnPrev( void );
    void OnBtnNext( void );
    void OnBtnP5Config( void );
    void OnVfSelectionChanged( int );

private:
    QBoxLayout * mainLayout;
    QFindDlg * parent;
};
